
 /*  Abstract:
 *
 *      C++ S-function which stores an C++ object in
 *      the pointers vector PWork.
 *
 *  Copyright 1990-2000 The MathWorks, Inc.
 * 
 */

#include "windows.h"

struct TVortexResponse
{
	double ActJointAngle[18];
	double ActJointVel[18];
	double ActLegForce[18];
	double OutArr[10];
};

struct TVortexQuery
{
	double Reset;
	double ActuatorActive[18];
	double MaxJointVel[18];
	double ActJointTorque[18];
	double InputArr[10];
};

struct TIPCQ
{
	unsigned long PacketNum;
	TVortexQuery VortexQuery;
};
struct TIPCR
{
	unsigned long PacketNum;
	TVortexResponse VortexResponse;
};


class  counter {
    double  x;
public:

HANDLE hResponseStream;
HANDLE hQueryStream;

LPVOID lpResponseStream;
LPVOID lpQueryStream;

void MapAllInterprocessFileViews();
void UnMapAllInterprocessFileViews();
void UpdateAllFileMapViews();
void MVUpdate();
void UpdateQuery();

TVortexResponse m_VortexResponse;
TVortexQuery m_VortexQuery;
long PacketNum;

    counter() {
        x = 0.0;
    }
    double output(void) {
        x = x + 2.0;
        return x; 
    }
};
//////////////////////////////// 
void counter::UnMapAllInterprocessFileViews()
{

	UnmapViewOfFile(lpResponseStream);
	CloseHandle(hResponseStream);

	UnmapViewOfFile(lpQueryStream);
	CloseHandle(hQueryStream);

}

//////////////////////////////// 
void counter::UpdateAllFileMapViews()
{

TIPCQ IPCQ;
TIPCR IPCR;

IPCQ.VortexQuery=m_VortexQuery;
if (m_VortexQuery.Reset) PacketNum=10;
IPCQ.PacketNum=PacketNum;
memcpy(lpQueryStream,&IPCQ,sizeof(TIPCQ));

memcpy(&IPCR,lpResponseStream,sizeof(TIPCR));
while (IPCR.PacketNum!=PacketNum) 
{
	Sleep(5);
	memcpy(&IPCR,lpResponseStream,sizeof(TIPCR));
}
	m_VortexResponse=IPCR.VortexResponse;
	PacketNum++;
}
//////////////////////////////// 
void counter::UpdateQuery()
{

TIPCQ IPCQ;
TIPCR IPCR;

IPCQ.VortexQuery=m_VortexQuery;

memcpy(lpQueryStream,&IPCQ,sizeof(TIPCQ));

}
//////////////////////////////// 
void counter::MapAllInterprocessFileViews()
{
  hResponseStream = CreateFileMapping(
                HANDLE(0xFFFFFFFF), // use paging file
                NULL,                // no security attributes
                PAGE_READWRITE,      // read/write access

                0,                   // size: high 32-bits
                sizeof(TIPCR)+1,           // size: low 32-bits
                "VR");    // name of map object
            
 lpResponseStream = MapViewOfFile(

                hResponseStream,     // object to map view of
                FILE_MAP_WRITE, // read/write access
                0,              // high offset:  map from
                0,              // low offset:   beginning
                0);             // default: map entire file
  
  hQueryStream = CreateFileMapping(
                HANDLE(0xFFFFFFFF), // use paging file
                NULL,                // no security attributes
                PAGE_READWRITE,      // read/write access

                0,                   // size: high 32-bits
                sizeof(TIPCQ)+1,           // size: low 32-bits
                "VQ");    // name of map object
            
  lpQueryStream = MapViewOfFile(

                hQueryStream,     // object to map view of
                FILE_MAP_WRITE, // read/write access
                0,              // high offset:  map from
                0,              // low offset:   beginning
                0);             // default: map entire file

  
   
    
	
if (!lpQueryStream)
		
	PacketNum=10;

}
//////////////////////////////// 


void counter::MVUpdate()
{
		 
	UpdateAllFileMapViews();

}


#ifdef __cplusplus
extern "C" { // use the C fcn-call standard for all functions  
#endif       // defined within this scope                     

#define S_FUNCTION_LEVEL 2
#define S_FUNCTION_NAME  mvexchanger

/*
 * Need to include simstruc.h for the definition of the SimStruct and
 * its associated macro definitions.
 */

#include "simstruc.h"
/*====================*
 * S-function methods *
 *====================*/

/* Function: mdlInitializeSizes ===============================================
 * Abstract:
 *    The sizes information is used by Simulink to determine the S-function
 *    block's characteristics (number of inputs, outputs, states, etc.).
 */
static void mdlInitializeSizes(SimStruct *S)
{
    /* See sfuntmpl_doc.c for more details on the macros below */

	int i;

    ssSetNumSFcnParams(S, 2);  /* Number of expected parameters */
    if (ssGetNumSFcnParams(S) != ssGetSFcnParamsCount(S)) {
        /* Return if number of expected != number of actual parameters */
        return;
    }

    ssSetNumContStates(S, 0);
    ssSetNumDiscStates(S, 0);

     if (!ssSetNumInputPorts(S, 4)) return;
    ssSetInputPortWidth(S, 0,18);//Motor Activation Flag[18]
    ssSetInputPortWidth(S, 1,18);//Max Joint Velocity[18]
    ssSetInputPortWidth(S, 2,18);//Actual Joint Moment[18]
    ssSetInputPortWidth(S, 3,10);//free float[10]

    
	for (i=0;i<=3;i++)
	{   
	    ssSetInputPortRequiredContiguous(S, i, true); /*direct input signal access*/
		ssSetInputPortDirectFeedThrough(S, i, 1);
	}
    
   if (!ssSetNumOutputPorts(S, 4)) return;
    ssSetOutputPortWidth(S, 0, 18);//Actual Joint Angle[18]
    ssSetOutputPortWidth(S, 1, 18);//Actual Joint Velocity[18]
    ssSetOutputPortWidth(S, 2, 18);//Actual Leg Force[18]
    ssSetOutputPortWidth(S, 3, 10);//free float[10]

    ssSetNumSampleTimes(S, 1);
    ssSetNumRWork(S, 0);
    ssSetNumIWork(S, 0);
    ssSetNumPWork(S, 1); // reserve element in the pointers vector
    ssSetNumModes(S, 0); // to store a C++ object
    ssSetNumNonsampledZCs(S, 0);

    ssSetOptions(S, 0);
}




/* Function: mdlInitializeSampleTimes =========================================
 * Abstract:
 *    This function is used to specify the sample time(s) for your
 *    S-function. You must register the same number of sample times as
 *    specified in ssSetNumSampleTimes.
 */
static void mdlInitializeSampleTimes(SimStruct *S)
{
    ssSetSampleTime(S, 0, mxGetScalar(ssGetSFcnParam(S, 0)));
    ssSetOffsetTime(S, 0, 0.0);


}

#define MDL_START  /* Change to #undef to remove function */
#if defined(MDL_START) 
  /* Function: mdlStart =======================================================
   * Abstract:
   *    This function is called once at start of model execution. If you
   *    have states that should be initialized once, this is the place
   *    to do it.
   */
  static void mdlStart(SimStruct *S)
  {
      ssGetPWork(S)[0] = (void *) new counter;
	  counter *c = (counter *) ssGetPWork(S)[0];
	  c->MapAllInterprocessFileViews();
		c->m_VortexQuery.Reset=1;
		c->m_VortexQuery.InputArr[0]=0;// store new C++ object in the
 if (mxGetScalar(ssGetSFcnParam(S, 1))==1) {
    WinExec("PSim engine.exe",SW_SHOW);
    Sleep(2000);	  
}
}                                            // pointers vector
#endif /*  MDL_START */

/* Function: mdlOutputs =======================================================
 * Abstract:
 *    In this function, you compute the outputs of your S-function
 *    block. Generally outputs are placed in the output vector, ssGetY(S).
 */
static void mdlOutputs(SimStruct *S, int_T tid)
{
    counter *c = (counter *) ssGetPWork(S)[0];   // retrieve C++ object  // the pointers vector and use

    const	real_T  *u1 = ssGetInputPortRealSignal(S,0);
	const	real_T  *u2 = ssGetInputPortRealSignal(S,1);
	const   real_T  *u3 = ssGetInputPortRealSignal(S,2);
	const	real_T  *u4 = ssGetInputPortRealSignal(S,3);

	
	real_T  *y1 = ssGetOutputPortRealSignal(S,0);
	real_T  *y2 = ssGetOutputPortRealSignal(S,1);
	real_T  *y3 = ssGetOutputPortRealSignal(S,2);
	real_T  *y4 = ssGetOutputPortRealSignal(S,3);

	for (int i=0;i<18;i++) c->m_VortexQuery.ActJointTorque[i]=u1[i];

	memcpy(c->m_VortexQuery.ActuatorActive,		u1,sizeof(c->m_VortexQuery.ActuatorActive));	//ActuatorActive
	memcpy(c->m_VortexQuery.MaxJointVel,		u2,sizeof(c->m_VortexQuery.MaxJointVel));		//MaxAngVel
	memcpy(c->m_VortexQuery.ActJointTorque,		u3,sizeof(c->m_VortexQuery.ActJointTorque));	//MaxTorque
	memcpy(c->m_VortexQuery.InputArr,			u4,sizeof(c->m_VortexQuery.InputArr));			//InputArr

	c->MVUpdate();
	c->m_VortexQuery.Reset=0;

	memcpy(y1,c->m_VortexResponse.ActJointAngle,	sizeof(c->m_VortexResponse.ActJointAngle));//JointAngle
	memcpy(y2,c->m_VortexResponse.ActJointVel,	sizeof(c->m_VortexResponse.ActJointVel));	//JointVel
	memcpy(y3,c->m_VortexResponse.ActLegForce,	sizeof(c->m_VortexResponse.ActLegForce));	//OutArr
	memcpy(y4,c->m_VortexResponse.OutArr,			sizeof(c->m_VortexResponse.OutArr));		
}									             


static void mdlTerminate(SimStruct *S)
{
    counter *c = (counter *) ssGetPWork(S)[0];
	c->m_VortexQuery.InputArr[9]=1;
	c->UpdateQuery();
	Sleep(2000);
	c->UnMapAllInterprocessFileViews();// retrieve and destroy C++
    delete c;                                  // object in the termination
}                                              // function


/*=============================*
 * Required S-function trailer *
 *=============================*/

#ifdef  MATLAB_MEX_FILE    /* Is this file being compiled as a MEX-file? */
#include "simulink.c"      /* MEX-file interface mechanism */
#else
#include "cg_sfun.h"       /* Code generation registration function */
#endif

#ifdef __cplusplus
} // end of extern "C" scope
#endif
